VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLabelNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'----------------------------------------
' Class for moving and handling nodes
' and relations in form or picturebox
'----------------------------------------
' 2002-03-15
' Major Blue Oy
' Toby
'----------------------------------------

Option Explicit

'----------------------------------------
' eFeedback:iin liittyvt
'----------------------------------------

Public QuestionName   As String  'this question name
Public QuestionType   As Integer 'this question type
Public BranchAmount   As Integer 'how many branches to downlevel - 1 (zerobased)
Public BranchValue    As String  'upper level values
Public Reference      As Boolean

'----------------------------------------
' Noden ksittelyyn ja liikutteluun liittyvt
'----------------------------------------

Private CurX    As Single
Private CurY    As Single
Private bMoving As Integer

Private PrintLine As VB.Line

Private mColParents           As Collection
Private mColLines             As Collection
Private mColChildren          As Collection

'... tytyyk takertua liikutettaessa johonkin nodeen
Private mvarGlueParent        As clsLabelNode
Private mvarGlueChild         As clsLabelNode

Private mvarParentForm        As frmDesign

Public Event Click(tNode As clsLabelNode)

Private WithEvents mvarCurLabel  As VB.Label 'local copy
Attribute mvarCurLabel.VB_VarHelpID = -1
Friend Property Get Key() As String
  Key = mvarCurLabel.Name
End Property
Friend Property Get Parents() As Collection
    Set Parents = mColParents
End Property
Friend Property Get Children() As Collection
    Set Children = mColChildren
End Property
Friend Property Get Lines() As Collection
    Set Lines = mColLines
End Property
Friend Property Set CurLabel(ByVal vData As VB.Label)
    Set mvarCurLabel = vData
    Set mvarCurLabel.Container = mvarParentForm.picNodes
    mvarCurLabel.Visible = True
End Property
Friend Property Get CurLabel() As VB.Label
    Set CurLabel = mvarCurLabel
End Property
Friend Property Get GlueParent() As clsLabelNode
    Set GlueParent = mvarGlueParent
End Property
Friend Property Set GlueParent(ByVal vData As clsLabelNode)
  Set mvarGlueParent = vData
End Property
Friend Property Get GlueChild() As clsLabelNode
    Set GlueChild = mvarGlueChild
End Property
Friend Property Set GlueChild(ByVal vData As clsLabelNode)
  Set mvarGlueChild = vData
End Property
Friend Property Set ParentForm(ByVal vData As frmDesign)
    Set mvarParentForm = vData
End Property
Friend Property Get ParentForm() As frmDesign
    Set ParentForm = mvarParentForm
End Property
Friend Sub RemoveParent(vData As clsLabelNode)
    
    If mColParents Is Nothing Then Exit Sub
    mColParents.Remove vData.Key
    If mColParents.Count = 0 Then Set mColParents = Nothing

End Sub
Friend Sub AddParent(vData As clsLabelNode)
  
  If vData Is Nothing Then Exit Sub
  
  If mColParents Is Nothing Then Set mColParents = New Collection
  mColParents.Add vData, vData.Key
  
  vData.MoveLine Me.CurLabel.Name, 1, vData.Middle, vData.Bottom
  vData.MoveLine Me.CurLabel.Name, 2, Me.Middle, Me.Top

End Sub

Friend Sub RemoveChild(vData As clsLabelNode)
    
  If mColChildren Is Nothing Then Exit Sub
  mColChildren.Remove vData.Key
  If mColChildren.Count = 0 Then Set mColChildren = Nothing

End Sub
Friend Sub AddChild(vData As clsLabelNode, Optional ByVal vData1 As VB.Line)
  
  If mColChildren Is Nothing Then Set mColChildren = New Collection
  mColChildren.Add vData, vData.Key
  
  If Not vData1 Is Nothing Then
    vData1.Tag = vData.CurLabel.Name
    Me.AddLine vData1
    Me.MoveLine vData.CurLabel.Name, 1, Me.Middle, Me.Bottom
    Me.MoveLine vData.CurLabel.Name, 2, vData.Middle, vData.Top
  End If
  
End Sub
Friend Function RemoveLine(vData As VB.Line) As Boolean
  
  Dim tNode As clsLabelNode
  
  If mColLines Is Nothing Then Exit Function
  On Error GoTo EH
  
  
  '.. find child and remove its parent
  '.. remove childline
10:  mColLines.Remove vData.Name
20:  If mColLines.Count = 0 Then Set mColLines = Nothing
30:  Set tNode = mColChildren(vData.Tag)
40:  mColChildren.Remove vData.Tag
50:  tNode.RemoveParent Me
60:  mvarParentForm.Controls.Remove vData.Name
80:  Set tNode = Nothing
90:  RemoveLine = True
     
     Exit Function

EH:
  
  '... hallittu virheilmoitus
  '... jos Line ei lydy, niin ei sit pitisikn
  
  If Erl > 20 Then Err.Raise Err.Number
  RemoveLine = False
  
End Function
Friend Sub AddLine(vData As VB.Line)

  If mColLines Is Nothing Then Set mColLines = New Collection
  mColLines.Add vData, vData.Name
  Set vData.Container = mvarParentForm.picNodes
  vData.Visible = True

End Sub
Friend Sub MoveLine(ByVal tName As String, ByVal Axis As Integer, ByVal X As Single, ByVal Y As Single)
  Dim tLine As VB.Line
  
  If Not mColLines Is Nothing Then
      For Each tLine In mColLines
          If tName = tLine.Tag Then
              If Axis = 1 Then
                  tLine.X1 = X
                  tLine.Y1 = Y
              ElseIf Axis = 2 Then
                  tLine.X2 = X
                  tLine.Y2 = Y
              End If
          End If
      Next
  End If
  
End Sub
Private Sub MoveLines()
    
    Dim tNode As clsLabelNode
    Dim tLine As VB.Line
    
    If Not mColParents Is Nothing Then
      For Each tNode In mColParents
        tNode.MoveLine Me.CurLabel.Name, 2, Me.Middle, Me.Top
      Next
    End If
    
    If Not mColChildren Is Nothing Then
      For Each tNode In mColChildren
        Me.MoveLine tNode.CurLabel.Name, 1, Me.Middle, Me.Bottom
      Next
    End If

End Sub
Friend Property Get Top() As Long
    Top = mvarCurLabel.Top
End Property
Friend Property Let Top(ByVal vData As Long)
    If vData >= 0 Then mvarCurLabel.Top = vData
End Property
Friend Property Get Left() As Long
    Left = mvarCurLabel.Left
End Property
Friend Property Let Left(ByVal vData As Long)
    If vData >= 0 Then mvarCurLabel.Left = vData
End Property
Friend Property Get Width() As Long
  Width = mvarCurLabel.Width
End Property
Friend Property Let Width(ByVal vData As Long)
    With mvarCurLabel
      If .Left + .Width < .Container.Width Then .Width = vData
    End With
End Property
Friend Property Get Height() As Long
    Height = mvarCurLabel.Height
End Property
Friend Property Let Height(ByVal vData As Long)
    If vData < mvarCurLabel.Container.Height Then
      mvarCurLabel.Height = vData
    End If
End Property
Friend Property Get Middle() As Long
    Middle = Me.Left + (Me.Width / 2)
End Property
Friend Property Let Middle(ByVal vData As Long)
    Me.Left = vData - (Me.Width / 2)
End Property
Friend Property Get Bottom() As Long
    Bottom = Me.Top + Me.Height
End Property
Friend Property Let Bottom(ByVal vData As Long)
    Me.Top = vData - Me.Top
End Property
Friend Property Get Right() As Long
    Right = Me.Left + Me.Width
End Property
Friend Property Let Right(ByVal vData As Long)
      Me.Left = Me.Right - vData
End Property
Private Sub myAddLine(X As Single, Y As Single)
    
    Dim tNode   As clsLabelNode
    Dim bFound  As Boolean
    Dim tX As Single
    Dim tY As Single
    tX = Me.Left + X
    tY = Me.Top + Y
    
    On Error GoTo NotFound
    For Each tNode In mvarParentForm.LabelNodes
        If tNode.Key <> Me.Key Then
          With tNode
              If .Top <= tY And .Top + .Height >= tY Then
                  If .Left <= tX And .Left + .Width >= tX Then
                      Set tNode.ParentForm = mvarParentForm
                      tNode.AddParent Me
                      Me.AddChild tNode, PrintLine
                      bFound = True
                      Exit For
                  End If
              End If
          End With
        End If
    Next

NotFound:

    If Not PrintLine Is Nothing Then
        If Not bFound Then mvarParentForm.Controls.Remove PrintLine.Name
        Set PrintLine = Nothing
    End If

End Sub

Private Sub mvarCurLabel_Click()
    
    mvarParentForm.SetCurNode Me
    RaiseEvent Click(Me)

End Sub

Private Sub mvarCurLabel_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim bFlag As Boolean
    bMoving = Button
    
    'create new line object
    If Button = vbLeftButton Then
        CurX = X
        CurY = Y
    ElseIf Button = vbRightButton Then
    
        '.. ei tarrautuvaa kakaraa
        If Not Me.GlueChild Is Nothing Then
            bFlag = False
        ElseIf Me.CurLabel.BackColor = mvarParentForm.lblJako.BackColor Then
            bFlag = True
        ElseIf mColLines Is Nothing Then
            bFlag = True
        ElseIf mColLines.Count = 0 Then
            bFlag = True
        End If
        
        If bFlag Then
          CurX = X
          CurY = Y
          With mvarParentForm
              Set PrintLine = .Controls.Add("VB.Line", "Line" & .Counter)
              Set PrintLine.Container = .picNodes
              PrintLine.Visible = True
              PrintLine.X1 = Me.Middle
              PrintLine.X2 = Me.Middle
              PrintLine.Y1 = Me.Bottom
              PrintLine.Y2 = Me.Bottom
          End With
        End If
    End If

End Sub

Private Sub mvarCurLabel_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Me.MouseMove True, Shift, X, Y, CurX, CurY, bMoving
    
    If Not mvarGlueParent Is Nothing Then
      mvarGlueParent.MouseMove False, Shift, X, Y, CurX, CurY, bMoving
    End If
    
End Sub

Public Sub MouseMove(bMoveChildren As Boolean, Shift As Integer, X As Single, Y As Single, iX As Single, iY As Single, iMoving As Integer)
    
    Dim tLabel As clsLabelNode
    Dim tFlag As Boolean
    Dim newX As Single
    Dim newY As Single
    
    If iMoving = vbLeftButton Then
        With Me
          
          newX = .Left + (X - iX)
          newY = .Top + (Y - iY)
          
          '.. do not let child raise over parent
          If Not mColParents Is Nothing Then
              For Each tLabel In mColParents
                  If tLabel.Bottom + 120 > .Top Then
                      newY = tLabel.Bottom + 120
                      .Top = newY
                      tFlag = True
                      Exit For
                  End If
              Next
          End If
          
          
'          If newX Mod 60 = 0 Then
              .Left = newX
              tFlag = True
'          End If
          
'          If newY Mod 60 = 0 Then
              .Top = newY
              tFlag = True
'          End If
          
        End With
        
        MoveLines 'True
        
        '..move also children (also GlueChild is part of Children)
        If bMoveChildren Then
        
            If tFlag And (Not mColChildren Is Nothing) Then
                For Each tLabel In mColChildren
                    tLabel.MouseMove bMoveChildren, Shift, X, Y, iX, iY, iMoving
                Next
            End If
            
        '.. move GlueParent with Me
        ElseIf Not mvarGlueParent Is Nothing Then
            
            mvarGlueParent.MouseMove bMoveChildren, Shift, X, Y, iX, iY, iMoving
        
        End If
    
    ElseIf iMoving = vbRightButton Then
        If Not PrintLine Is Nothing Then
            With PrintLine
                .X2 = X + Me.Left
                If (Y + Me.Top) > .Y1 Then .Y2 = Y + Me.Top
            End With
        End If
    End If

End Sub


Private Sub mvarCurLabel_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If bMoving = vbRightButton Then myAddLine X, Y
    bMoving = 0
    CurX = 0
    CurY = 0

End Sub

Friend Sub WillTerminate()
  
  Dim tObj As Object
  
  Set mvarParentForm = Nothing
  Set mvarCurLabel = Nothing
  
  If Not mColChildren Is Nothing Then
      For Each tObj In mColChildren
          Set tObj = Nothing
      Next
      Set mColChildren = Nothing
  End If
  
  If Not mColParents Is Nothing Then
      For Each tObj In mColParents
          Set tObj = Nothing
      Next
      Set mColParents = Nothing
  End If
  
  If Not mColLines Is Nothing Then
      For Each tObj In mColLines
          Set tObj = Nothing
      Next
      Set mColLines = Nothing
  End If
  

End Sub
